#ifndef MOUSE_H
#define MOUSE_H


// - HEADERS ---------------------------------------------------

#include <windows.h>

#include "oscreen.h"


// - MACROS ----------------------------------------------------

#define MOUSE_NUMBUTTONS 2

#define MOUSE_BUTTON_1 0
#define MOUSE_BUTTON_2 1


// - OBJECTS ---------------------------------------------------

class oMouse
{
public:
	int m_WM_x, m_WM_y, m_VX, m_VY;
	bool Button[ MOUSE_NUMBUTTONS ];
private:
	int m_X, m_Y;

public:
	oMouse() {Create();}
	void Create(void);
	void Set(int x, int y);
	void Update(bool Moving=false);
	inline int VX() {return m_VX;}
	inline int VY() {return m_VY;}
	inline int X()  {return m_X;}
	inline int Y()  {return m_Y;}
};


// - EXTERNALS -------------------------------------------------

extern oMouse Mouse;


#endif

