// oFont.h: interface for the oFont class.
//
//////////////////////////////////////////////////////////////////////
#if defined(TINYGL) || defined(TRENKI3D)

#if !defined(AFX_OFONT_H__5E0BC601_573C_41F8_9263_AAD29DF4C678__INCLUDED_)
#define AFX_OFONT_H__5E0BC601_573C_41F8_9263_AAD29DF4C678__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "obitmap.h"

struct GLR_FONTKERNING;


class oFont  
{
public:
	oFont();
	~oFont();
	void	Print(const char* text, int x, int y, const GLR_FONTKERNING* pKern=NULL);
	bool	CreateBy(OPENGL_IMAGE& img);
	void	Delete();
	short	m_cwidth, m_cheight;
private:
	oBitmap	m_blocks[256];
	int		m_charset;
};

#endif // !defined(AFX_OFONT_H__5E0BC601_573C_41F8_9263_AAD29DF4C678__INCLUDED_)

#endif // #if defined(TINYGL) || defined(TRENKI3D)


