// - HEADERS ---------------------------------------------------
#include "Stdafx.h"

#include "oKeyboard.h"
#include "ceFramework.h"

// - GLOBALS ---------------------------------------------------

oKeyboard Keyboard;




#ifdef _WIN32_WCE
/*
Hardware1 = 193 == 0xC1
Hardware2 = 194 == 0xC2
Hardware3 = 195 == 0xC3
Hardware4 = 196 == 0xC4
Hardware5 = 197 == 0xC5

D-Pad:
up  :  0x26
down:  0x28
left:  0x25
right: 0x27
press: 0x0d (SDA)


// T-Mobile SDA 2
POWER: 0xC4|0x81
SoftL: 0x75|0x79
SoftR: ??
Lmenu: 0x70
home : 0x5b
back : 0x1B back/ESC
Rmenu: 0x71

           SDA music:
(@t) : 0xB6  (@t)
calen: 0xB1  prev
email: 0xB3  play
sms  : 0xB0  next

dial : 0x72
hangup 0x73
0-9  : 0x30-0x39
*    : 0x77
#    : 0x78
*/

/*

#define VK_ANSWER      0x72
#define VK_HANGUP      0x73
TerminateProcess(...);  // kill cprog.exe
RegisterHotKey(..., 1, 0, VK_ANSWER);  // steal hotkey
RegisterHotKey(..., 1, 0, VK_HANGUP);  // steal hotkey 



None = 0
Alt = 1
Control = 2
Shift = 4
Windows = 8
Modkeyup = &H1000

Hardware1 = 0xc1
Hardware2 = 0xc2
Hardware3 = 0xc3
Hardware4 = 0xc4
Hardware5 = 0xca


<DllImport("coredll.dll", Entrypoint:="RegisterHotKey", setLastError:=True)>
Public Function RegisterHotKey(ByVal hWnd As IntPtr,ByVal id As Integer,ByVal Modifiers As KeyModifiers,ByVal key As Integer) As Boolean


<DllImport("coredll.dll")>
UnregisterFunc1( ByVal modifiers As KeyModifiers, ByVal keyID As Integer) As Boolean


 UnregisterFunc1(KeyModifiers.None, CType(KeysHardware.Answer, Integer))
RegisterHotKey(hWnd, Answer, KeyModifiers.None, Answer)

UnregisterFunc1(KeyModifiers.None, Hangup)
RegisterHotKey(hWnd, Hangup, KeyModifiers.None, Hangup)


UnregisterFunc1(Windows, Hardware1)
RegisterHotKey(hWnd, Hardware1, Windows, Hardware1)

UnregisterFunc1(Windows, Hardware2)
RegisterHotKey(hWnd, Hardware2, Windows, Hardware2)

UnregisterFunc1(Windows, Hardware3)
RegisterHotKey(hWnd, Hardware3, Windows, Hardware3)

UnregisterFunc1(Windows, Hardware4)
RegisterHotKey(hWnd, Hardware4, Windows, Hardware4)

UnregisterFunc1(Windows, Hardware5)
RegisterHotKey(hWnd, Hardware5, Windows, Hardware5)
*/


HINSTANCE hCoreDll=NULL;
typedef BOOL (__stdcall *UnregisterFunc1Proc)( UINT, UINT );
UnregisterFunc1Proc procUndergisterHotKey=NULL;

void oKeyboard::InitGrabButtons(HWND hwnd)
{
//  memset(hooktab,0,15*sizeof(int));
  hGrabWindow = hwnd;
}

/*
void oKeyboard::UngrabButton(int keyid)
{
//	hooktab[keyid-0xC1] = 0;
	if(procUndergisterHotKey)
		UnregisterHotKey(hGrabWindow, keyid);
}
*/

void oKeyboard::GrabButton(int keyid, bool grab)
{
#ifndef SHCMBM_OVERRIDEKEY
	#define SHCMBM_OVERRIDEKEY (WM_USER+403)
#endif

#ifndef SHMBOF_NODEFAULT
	#define SHMBOF_NODEFAULT 1
	#define SHMBOF_NOTIFY 2
#endif


#ifndef VK_TBACK
	#define VK_TBACK				0x1b

	#define VK_TSOFT1				0x70 // Softkey 1
	#define VK_TSOFT2				0x71 // Softkey 2

	#define VK_TTALK				0x72 // Talk
	#define VK_TEND					0x73 // End

	#define VK_THOME				0x5b // Home
	#define VK_TACTION				0x0d // Action
	#define VK_TRECORD				0x79 // Record
	#define VK_TFLIP				0x80 // Flip
	#define VK_TPOWER				0x81 // Power
	#define VK_TVOLUMEUP			0x75 // Volume Up
	#define VK_TVOLUMEDOWN			0x76 // Volume Down
	#define VK_TSPEAKERPHONE_TOGGLE	0x7f

	#define VK_APP1					0xC1
	#define VK_APP2					0xC2
	#define VK_APP3					0xC3
	#define VK_APP4					0xC4
	#define VK_APP5					0xC5
	#define VK_APP6					0xC6
#endif

	if(grab)
	{
		if(procUndergisterHotKey)
		{
			procUndergisterHotKey(MOD_WIN, keyid); // First unregister, _then_ register
			::SendMessage(hGrabWindow, SHCMBM_OVERRIDEKEY, keyid, MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY, SHMBOF_NODEFAULT));
			::RegisterHotKey(hGrabWindow, keyid, MOD_WIN, keyid);
		}
	}
	else
	{
		if(procUndergisterHotKey)
		{
			::SendMessage(hGrabWindow, SHCMBM_OVERRIDEKEY, keyid, MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY, 0));
			::UnregisterHotKey(hGrabWindow, keyid);
		}
	}
}

void oKeyboard::ActivateButtons(bool active)
{
int i;
	if(!hGrabWindow) return;
	if(active)
	{
		if(GXOpenInput) GXOpenInput();
	}
	else
	{
g_debug("GXCloseInput (if)\n");
		if(GXCloseInput) GXCloseInput();
	}
g_debug("procUndergisterHotKey: %d\n",(int)procUndergisterHotKey);
	GrabButton(VK_TPOWER,      active);
	GrabButton(VK_TVOLUMEUP,   active);
	GrabButton(VK_TRECORD,     active);
	GrabButton(VK_TVOLUMEDOWN, active);
	GrabButton(VK_TSOFT1,      active); // LMenu
	GrabButton(VK_THOME, active); // Home
	GrabButton(VK_TBACK, active); // Back
	GrabButton(VK_TSOFT2,active); // RMenu

	// SDA I ??
	GrabButton(0xB6,     active); // @t
	GrabButton(0xB1,     active); // prev/calender
	GrabButton(0xB3,     active); // play/email
	GrabButton(0xB0,     active); // next/sms

	// PocketPC buttons
/*
	for(i=0; i<15; i++)
	{
		GrabButton(i+0xC1, active);
	}
*/
	GrabButton(VK_APP1,  active); // @t
	GrabButton(VK_APP2,  active); // prev/calender
	GrabButton(VK_APP3,  active); // play/email
	GrabButton(VK_APP4,  active); // next/sms
	GrabButton(VK_APP5,  active); // 
	GrabButton(VK_APP6,  active); // 

	GrabButton(VK_TTALK, active); // dial
	GrabButton(VK_TEND,  active); // hangup


g_debug("ActivateButtons - end\n");

}

#else
void oKeyboard::InitGrabButtons(HWND){}
void oKeyboard::GrabButton(int, bool){}
void oKeyboard::ActivateButtons(bool){}
#endif

// - MEMBER FUNCTIONS ------------------------------------------
oKeyboard::oKeyboard()
{
#ifdef _WIN32_WCE
	hCoreDll = LoadLibrary(TEXT("coredll.dll"));
	if(hCoreDll)
	{
		procUndergisterHotKey = (UnregisterFunc1Proc)GetProcAddress( hCoreDll, _T("UnregisterFunc1"));
	}
#endif
}
oKeyboard::~oKeyboard()
{
	Delete();
#ifdef _WIN32_WCE
	FreeLibrary(hCoreDll);
#endif
}

void oKeyboard::Create(HWND hwnd)
{
	hGrabWindow=NULL;
	InitGrabButtons(hwnd);
	ActivateButtons(true);
}

void oKeyboard::Delete(void)
{
	ActivateButtons(false);
}


int oKeyboard::GetMappedKeyState(int keycode)
{
#define ISDOWN(a, b)   if(b==keycode            ) {return ((GetAsyncKeyState(a)<0) ? 1 : 0);} //&0x8000);
#define ISDOWN2(a,b,c) if(b==keycode||c==keycode) {return ((GetAsyncKeyState(a)<0) ? 1 : 0);} //&0x8000);

	// D-Pad
	if (Screen.Landscape)
	{
		ISDOWN(VK_DOWN,203);
		ISDOWN(VK_UP,205);
		ISDOWN(VK_LEFT,200);
		ISDOWN(VK_RIGHT,208);
	}
	else
	{
		ISDOWN(VK_LEFT,203);
		ISDOWN(VK_RIGHT,205);
		ISDOWN(VK_UP,200);
		ISDOWN(VK_DOWN,208);
	}
	ISDOWN(0x0D, 28);      // d-pad press / Return
	
	// Num-Pad
	ISDOWN2(0x31,  2, 71); // 1 on main KB, numpad 7
	ISDOWN2(0x32,  3, 72); // 2 on main KB, numpad 8
	ISDOWN2(0x33,  4, 73); // 3 on main KB, numpad 9
	ISDOWN2(0x34,  5, 75); // 4 on main KB, numpad 4
	ISDOWN2(0x35,  6, 76); // 5 on main KB, numpad 5
	ISDOWN2(0x36,  7, 77); // 6 on main KB, numpad 6
	ISDOWN2(0x37,  8, 79); // 7 on main KB, numpad 1
	ISDOWN2(0x38,  9, 80); // 8 on main KB, numpad 2
	ISDOWN2(0x39, 10, 81); // 9 on main KB, numpad 3
	ISDOWN2(0x30, 11, 82); // 0 on main KB, numpad 0

	ISDOWN2(0x77, 27, 55); // + on main KB, * on numpad
	ISDOWN2(0x78, 43, 83); // # on main KB, , on numpad
	
	// call/hangup
	ISDOWN(0x72,211);      // dial,   del
	ISDOWN(0x73,207);      // hangup, end
	
	// Home/Back
	ISDOWN(0x5b, 199);     // home,   Pos1
	ISDOWN2(0x1b,   1, 14) // back,   ESC, BCKSP

	// left/right menu
	ISDOWN(0x70, 59);      // left  menu, F1
	ISDOWN(0x71, 60);      // right menu, F2
	
	// 4 app-buttons
	ISDOWN(0xB6, 67);      // (@t), F9
	ISDOWN(0xB1, 68);      // prev, F10
	ISDOWN(0xB3, 87);      // play, F11
	ISDOWN(0xB0, 88);      // next, F12

	#ifdef _WIN32_WCE
		//                             iPAQ3600 
		ISDOWN(0xC1,199); // Button 1 (kalender ) = VK_HOME
		ISDOWN(0xC2,207); // Button 2 (mail     ) = VK_END
		ISDOWN(0xC3,210); // Button 3 (Q        ) = VK_INSERT
		ISDOWN(0xC4,211); // Button 4 (->       ) = VK_DELETE
		ISDOWN2(0xC5,29,157);  // Button 5 (audiorec ) = VK_CONTROL
	#else
		ISDOWN(VK_INSERT,210);
		ISDOWN(VK_HOME,199);  // y
		ISDOWN(VK_DELETE,211);// x
		ISDOWN(VK_END,207);
		ISDOWN2(VK_CONTROL,29,157);
		ISDOWN(VK_ESCAPE,1);
	#endif


	// For Win CE desktop devices
	return ((GetAsyncKeyState(keycode)<0) ? 1 : 0);
/*
60 = 3C
*/

#undef ISDOWN2
#undef ISDOWN
}
