// - HEADERS ---------------------------------------------------
#include "Stdafx.h"

#include "oMouse.h"


// - GLOBALS ---------------------------------------------------

oMouse Mouse;

// - MEMBER FUNCTIONS ------------------------------------------

void oMouse::Create(void)
{
	m_X = m_Y = 0;
	memset(Button, false, MOUSE_NUMBUTTONS);
}

void oMouse::Set(int x, int y)
{
	m_X=x; m_Y=y;
	if (Screen.Landscape)
	{
		m_WM_x = m_Y;
		m_WM_y = Screen.getWidth()-m_X;
	}
	else
	{
		m_WM_x = m_X;
		m_WM_y = m_Y;
	}
}

void oMouse::Update(bool Moving)
{
/*
	#define ISDOWN(a) ((GetAsyncKeyState(a)<0) ? 1 : 0); //&0x8000);
	memset(Button, false, MOUSE_NUMBUTTONS);
	Button[0] = ISDOWN(VK_LBUTTON);
	Button[1] = ISDOWN(VK_RBUTTON);
*/
	// Calculate the relative movement of the cursor:
	if (Screen.Landscape)
	{
		if(Moving)
		{
			m_VX += ((Screen.getWidth() - m_WM_y)-m_X);
			m_VY += (m_WM_x - m_Y);
		}
		m_Y = m_WM_x;
		m_X = (Screen.getWidth() - m_WM_y);
	}
	else
	{
		if(Moving)
		{
			m_VX +=(m_WM_x - m_X);
			m_VY +=(m_WM_y - m_Y);
		}
		m_X = m_WM_x;
		m_Y = m_WM_y;
	}
}
