/*
#include <Iphlpapi.h>
*/
typedef struct gf_IP_ADAPTER_INFO {
	struct gf_IP_ADAPTER_INFO* Next;
	unsigned long ComboIndex;
	char AdapterName[256 + 4];
	char Description[128 + 4];
	unsigned long AddressLength;
	unsigned char Address[8];
  DWORD Index;
  UINT Type;
  UINT DhcpEnabled;
  const char* CurrentIpAddress;
  const char* IpAddressList;
  const char* GatewayList;
  const char* DhcpServer;
  long HaveWins;
  const char* PrimaryWinsServer;
  const char* SecondaryWinsServer;
  __int64 LeaseObtained;
  __int64 LeaseExpires;
} gf_IP_ADAPTER_INFO, *gf_PIP_ADAPTER_INFO;


#ifdef UNICODE
#define iphlp_dll	L"iphlpapi.dll"
#define iphlp_func_name   L"GetAdaptersInfo"
#else
#define iphlp_dll	"iphlpapi.dll"
#define iphlp_func_name   "GetAdaptersInfo"
#endif

static unsigned long __GetComputerId(void)
{
static unsigned long My_ID=0;
	if(My_ID) return My_ID;
	unsigned long dwStatus = 1;
	unsigned long mac = 0x1ab4ef82; // In case you can't get none
	gf_IP_ADAPTER_INFO AdapterInfo[16];// Allocate information 
	// for up to 16 NICs
	DWORD dwBufLen = sizeof(AdapterInfo);  // Save memory size of buffer

	HMODULE hi=LoadLibrary(iphlp_dll);
	typedef  unsigned long(__stdcall *fu_GetAdaptersInfo)(gf_PIP_ADAPTER_INFO, unsigned long*);
	if(!hi) return mac;
	fu_GetAdaptersInfo _GetAdaptersInfo= (fu_GetAdaptersInfo)GetProcAddressA(hi, (LPCSTR)iphlp_func_name);
	if(_GetAdaptersInfo) dwStatus = _GetAdaptersInfo(AdapterInfo, &dwBufLen);
	FreeLibrary(hi);
	if(dwStatus) {My_ID=mac; return mac;}
	mac=0;
	gf_PIP_ADAPTER_INFO pAdapterInfo = AdapterInfo;
	do
	{
		unsigned long tmac=0;
		for(long i=0; i<5; ++i) // Leaving one since unsigned long's too short
		{
			tmac*=0x100;
			tmac+=(unsigned char)pAdapterInfo->Address[i];
		}
		if (tmac>mac)mac=tmac;
		pAdapterInfo = pAdapterInfo->Next;
	}
	while(pAdapterInfo);                    // Terminate if last adapter
	My_ID = mac^0x1d3a83d9;
	return My_ID;
}

#define MAX_CC	(2*26+10) //  + 7+ 6) - no umlauts and special signs
inline void __Ma61c_C0d3(char* cc1, char* cc2, unsigned long max_cc, unsigned int magic)
{
unsigned long	i, n=0;
char			cx;
unsigned long	rnd=13334+(unsigned)magic*3, rnd2=124122+(unsigned)magic*2;
#define ADDONE(a) if(n+1<max_cc) cc1[n++]=a;
	for (cx='a'; cx<='z'; cx++) ADDONE(cx); // 26
	for (cx='A'; cx<='Z'; cx++) ADDONE(cx); // 26
	for (cx='0'; cx<='9'; cx++) ADDONE(cx);  // 10
	ADDONE(''); ADDONE(''); ADDONE(''); ADDONE(''); ADDONE(''); ADDONE(''); ADDONE('') // 7
	ADDONE(' '); ADDONE('-'); ADDONE('.'); ADDONE('+'); ADDONE('/'); ADDONE('@'); // 6

	for (i=0; i<max_cc; ++i) cc2[i] = cc1[i]; // memcpy
	for (i=0; i<123342+magic%12341; i++)
	{
		rnd+=rnd; rnd*=i; ++rnd;
		cx = cc2[rnd%max_cc];
		rnd2+=((rnd*rnd2+magic+13)%rnd);
		cc2[rnd%max_cc] = cc2[rnd2%max_cc];
		cc2[rnd2%max_cc]   = cx;
	}
}
#define swap(a, b)	cx=c[(unsigned)(a)%i]; c[a]=c[(unsigned)(b)%i]; c[(unsigned)(b)%i]=cx;

// Encrypt
inline void __3nc2yp7(char* c, unsigned int magic)
{
long	i, n;
char	cc1[MAX_CC+1], cc2[MAX_CC+1], cx;
	__Ma61c_C0d3(cc1, cc2, MAX_CC, magic);
	for (n=0; n<(long)strlen(c); n++)
	{
		for(i=0; i<MAX_CC; i++)
		{
			if(c[n] == cc1[i])
			{
				c[n] = cc2[i];
				break;
			}
		}
	}
	// Now swap some chars
	i=(long)strlen(c);
	for (n=0; n<i; ++n)
	{
		swap(n, n+n+3+magic);
	}
}

// Decrypt
inline void __D3c2yp7(char* c, unsigned int magic)
{
long	i, n;
char	cc1[MAX_CC+1], cc2[MAX_CC+1], cx;
	__Ma61c_C0d3(cc1, cc2, MAX_CC, magic);
	// Re-swap chars
	i=(long)strlen(c);
	for (n=i-1; n>=0; --n)
	{
		swap(n, n+n+3+magic);
	}
	// Decrypt the string
	for (n=0; n<(long)strlen(c); n++)
	{
		for(i=0; i<MAX_CC; i++)
		{
			if(c[n] == cc2[i])
			{
				c[n] = cc1[i];
				break;
			}
		}
	}
}

#undef swap






