
#import <Foundation/Foundation.h>

// extern "C"
char gSomePath[1024]="";

const char* MacGetExePath()
{
	static char pwd[1024]="";
	NSString *path = [[NSBundle mainBundle] executablePath];

	// /User/hirokanakwa/Desktop/glb.app/Contents/MacOS/MacOS
	
	if (path == nil)
	{
		NSString *path = [[NSBundle mainBundle] bundlePath]; // /var/mobile/Applications/B8FA7A79-FB40-4238-A5E8-FDC5BEF716CC/Launcher.app/KaotikTest.bundle
		if(pwd[0]==0) 
		{
			getcwd(pwd, 1023);
		}
		strcpy(gSomePath, [path UTF8String]);
	}
	else
		strcpy(gSomePath, [path UTF8String]);

	return gSomePath;
}

const char* MacGetDocumentsPath()
{
	// documents path
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *path = [paths objectAtIndex:0];
	strcpy(gSomePath, [path UTF8String]);
	return gSomePath;
}


const char* MacSettingsDir()
{
// ~/Library/Application Support/<app-identifier>

	char plist[1024]="";
	int pos=0;
	strcpy(plist, MacGetExePath());


	// /User/hirokanakwa/Desktop/glb.app/Contents/MacOS/MacOS
	// reverse find ".app/"
	// and trim, so that .app is the end
	for(pos = strlen(plist)-4; pos>=0; --pos)
	{
		if(plist[pos]=='.' && plist[pos+1]=='a' && plist[pos+2]=='p' && plist[pos+3]=='p' && plist[pos+4]=='/')
		{
			plist[pos+4]='\0';
			break;
		}
	}
	strcat(plist, "/Contents/Info.plist");

	// documents path
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory, NSUserDomainMask, YES);
	NSString *path = [paths objectAtIndex:0];
	strcpy(gSomePath, [path UTF8String]);


	// append ID
	NSString *str_plist = [[NSString alloc]initWithUTF8String: plist ];
	NSMutableDictionary *dict = [NSMutableDictionary dictionaryWithContentsOfFile: str_plist ];
	if(dict)
	{
		strcat(gSomePath, "/");

		NSString* obj = [dict objectForKey:@"CFBundleIdentifier"];

		strcat(gSomePath, [obj UTF8String]);
	}

	mkdir(gSomePath, (mode_t)0755);
	return gSomePath;
}