// ------------------------ //
DGInt DrawButton(DGInt px, DGInt py, DGInt dx, DGInt dy, DGInt c1, DGInt c2, DGInt c3)
{
	FILLRECT( px, py, px+dx, py+dy, c2);
	DRAWLINE( px, py, px+dx-1, py, c1);
	DRAWLINE( px, py, px, py+dy-1, c1);
	DRAWLINE( px+dx, py+1, px+dx, py+dy, c3);
	DRAWLINE( px+1, py+dy, px+dx, py+dy, c3);
	return 0;
}

// filename$ 
// ------------------------ //
DGInt DrawButtonText(DGStr t_Str, DGInt px, DGInt py, DGInt dx, DGInt dy, DGInt c1, DGInt c2, DGInt c3)
{
	REGISTER_VAR_DEF(DGInt, fx,0);
	REGISTER_VAR_DEF(DGInt, fy,0);
	DrawButton(px, py, dx, dy, c1, c2, c3) ;
	GETFONTSIZE( fx, fy);
	px = px + (dx - LEN(t_Str)*fx)/2;
	py = py + (dy - fy)/2;
	c1=RGB(255,255,255) ;
	// select:
	if( (t_Str ) == (CGStr("{") ) ){DRAWLINE( px+fx/2, py+fy/3,   px,    py,      c1);
	DRAWLINE( px+fx/2, py+fy/3,   px+fx, py,      c1);
	DRAWLINE( px+fx/2, py+fy*.83, px   , py+fy/2, c1);
	DRAWLINE( px+fx/2, py+fy*.83, px+fx, py+fy/2, c1);
	} else if( (t_Str ) == (CGStr("}") ) ){DRAWLINE( px+fx/2, py,      px,    py+fy/3,   c1);
	DRAWLINE( px+fx/2, py,      px+fx, py+fy/3,   c1);
	DRAWLINE( px+fx/2, py+fy/2, px   , py+fy*.83, c1);
	DRAWLINE( px+fx/2, py+fy/2, px+fx, py+fy*.83, c1);
	} else {PRINT( t_Str, px, py);
	}
	return 0;
}


// ------------------------------------------------------------- // 
// -=#  FILEDIALOG  #=- 
// ------------------------------------------------------------- // 
// ------------------------ //
DGStr FileDialog_Str(DGStr filter_Str, DGInt must_exist, DGInt pos_x, DGInt pos_y, DGInt size_x, DGInt size_y)
{
DGInt caret=0, fin=0, rul_size=0, r_len=0, r_top=0, bn_clicked=0, ky_hold=0;
	// Diese Variablen sind als LOCAL definiert: 
	// open, filter$, filename$, 
	REGISTER_VAR(DGStrArray, files_Str);
	REGISTER_VAR_DEF(DGInt, i,0);
	REGISTER_VAR_DEF(DGInt, offset,0);
	REGISTER_VAR(DGStr, old_dir_Str);
	REGISTER_VAR_DEF(DGInt, font_x,0);
	REGISTER_VAR_DEF(DGInt, font_y,0);
	REGISTER_VAR_DEF(DGInt, num,0);
	REGISTER_VAR_DEF(DGInt, max_file,0);
	REGISTER_VAR_DEF(DGInt, max_text,0);
	REGISTER_VAR_DEF(DGInt, max_show,0);
	REGISTER_VAR_DEF(DGInt, r_width,0);
	REGISTER_VAR(DGStr, displ_Str);
	REGISTER_VAR_DEF(DGInt, mx,0);
	REGISTER_VAR_DEF(DGInt, my,0);
	REGISTER_VAR_DEF(DGInt, b2,0);
	REGISTER_VAR_DEF(DGInt, b1,0);
	REGISTER_VAR(DGStr, name_Str);
	REGISTER_VAR_DEF(DGInt, n_selected,0);
	REGISTER_VAR(DGStr, curdir_Str);
	REGISTER_VAR_DEF(DGInt, c_lite,0);
	REGISTER_VAR_DEF(DGInt, c_norm,0);
	REGISTER_VAR_DEF(DGInt, c_dark,0);
//	LOADFONT( CGStr("filereqf.bmp"), 2);
//	SETFONT( 2);
	r_width=12;
	// Width of ruler 
	c_lite = RGB(0xc0, 0xd0, 0xff) ;
	c_norm = RGB(0x40, 0x40, 0xa0) ;
	c_dark = RGB(0x20, 0x20, 0x80) ;
//	USEASBMP();
	// Store current back buffer for drawing 
	old_dir_Str = GETCURRENTDIR_Str() ;
	GETFONTSIZE( font_x, font_y);
	// Buttons... 
	size_y = size_y - font_y*4 - 13 - 1;
	// - 6 
	pos_x=pos_x+6;
	size_x=size_x-font_x;
	pos_y=pos_y+6+font_y+1;
sort_n_show:;
	offset=0;
	n_selected=-1;
	
	num = INSTR(filter_Str, CGStr("|"));
	if (num>-1)
	{
		DGStrArray filters;
		if(SPLITSTR(filter_Str, filters, CGStr("|")) > 1)
		{
			filter_Str = filters(1);
		}
		else
		{
			filter_Str=CGStr("");
		}
	}
	
	num = GETFILELIST(filter_Str, files_Str()) ;
	// For return value see manual 
	max_show=INTEGER(size_y/font_y) ;
	max_file=BOUNDS(files_Str(), 0)-1;
	max_text=INTEGER((size_x-r_width)/font_x) ;
	for (i = 0 ; i<= INTEGER(num/0x10000)-1; i++)
	{
		// mark directories 
		files_Str(i) = CGStr("/")+files_Str(i) ;
	}
	curdir_Str=GETCURRENTDIR_Str() ;
	if (LEN(curdir_Str) > max_text+1)
	{
		curdir_Str = CGStr("...")+MID_Str(curdir_Str, LEN(curdir_Str)-max_text+3, max_text-3) ;
	}
	while( TRUE)
	{
		PRINT( num, 0, 0);
		// Dialog: 
		DrawButton(pos_x-6, pos_y-font_y-6, size_x+12, size_y+font_y*4+13, c_lite, c_norm, c_dark) ;
		DrawButtonText(curdir_Str, pos_x, pos_y-font_y-5, size_x, font_y+2, c_dark, c_norm, c_lite) ;
		// Input 
		caret=caret+1;
		displ_Str=name_Str ;
		if (MOD(caret/30, 2) )
		{
			displ_Str = displ_Str+CGStr("|") ;
		}
		else
		{
			displ_Str = displ_Str+CGStr(" ") ;
		}
		PRINT( CGStr("File:"), pos_x+font_x, pos_y+size_y);
		DrawButtonText(displ_Str, pos_x+font_x, pos_y+size_y+font_y, size_x-2*font_x, font_y+2, c_dark, c_norm, c_lite) ;
		// OK / Abort 
		DrawButtonText(CGStr("OK"), pos_x+font_x, pos_y+size_y+font_y*2+5, size_x/3, font_y, c_lite, c_norm, c_dark) ;
		DrawButtonText(CGStr("Exit"), pos_x+size_x*2/3-font_x, pos_y+size_y+font_y*2+5, size_x/3, font_y, c_lite, c_norm, c_dark) ;
		// List show 
		DrawButton(pos_x, pos_y-1, size_x, size_y+2, c_dark, c_norm, c_lite) ;
		fin = max_file;
		if (fin>=offset+max_show )
			fin=offset+max_show-1;
		for (i = offset ; i<= fin; i++)
		{
			if (n_selected == i)
			{
				FILLRECT( pos_x, pos_y+(i - offset)*font_y, pos_x+size_x-r_width, pos_y+(i - offset + 1)*font_y, c_dark);
				ALPHAMODE( 1);
			}
			displ_Str = files_Str(i) ;
			if (LEN(displ_Str) > max_text)
			{
				displ_Str = MID_Str(displ_Str, 0, max_text-2) + CGStr("..") ;
			}
			// Draw folder-icon 
			if (MID_Str(displ_Str, 0, 1) == CGStr("/") )
				displ_Str = CGStr("<") + MID_Str(displ_Str, 1, 2048) + CGStr(">") ;
			PRINT( displ_Str, pos_x+1, pos_y+(i - offset)*font_y);
			ALPHAMODE( 0);
		}
		// Ruler 
		FILLRECT( pos_x+size_x-r_width, pos_y, pos_x+size_x-2, pos_y+size_y, c_dark);
		rul_size = max_show / max_file;
		if (rul_size<1)
		{
			// not all files visible 
			r_len = (max_show/max_file)*(size_y-font_y) ;
			r_top = (size_y - 2*font_y - r_len) * (offset/(max_file-max_show)) + font_y;
			DrawButtonText(CGStr("}"), pos_x+size_x-r_width, pos_y, r_width-1, font_y-1, c_lite, c_norm, c_dark) ;
			DrawButtonText(CGStr("{"), pos_x+size_x-r_width, pos_y+size_y-font_y, r_width-1, font_y, c_lite, c_norm, c_dark) ;
			DrawButton(pos_x+size_x-r_width, pos_y+r_top, r_width-1, r_len, c_lite, c_norm, c_dark) ;
		}
		MOUSESTATE( mx, my, b1, b2);
		STARTPOLY( -1);
		POLYVECTOR( mx, my, 0,0, c_lite);
		POLYVECTOR( mx+10, my+18, 0,0,c_norm);
		POLYVECTOR( mx+20, my+27 ,0,0,c_norm);
		POLYVECTOR( mx+27, my+20 ,0,0,c_norm);
		POLYVECTOR( mx+18, my+10 ,0,0,c_norm);
		ENDPOLY();
		mx=mx-pos_x;
		my=my-pos_y;
		if (b1)
		{
			bn_clicked=0;
			if (mx>size_x-r_width AND mx<size_x AND rul_size<1)
			{
				// Ruler clicked 
				if (my>=font_y AND my<=size_y-font_y)
				{
					// Ruler 
					offset = INTEGER(( (my-font_y)/(size_y-2*font_y) ) * max_file) ;
				}
				else
				{
					if (my>0 AND my<font_y )
						offset=offset-1;
					if (my>size_y-font_y AND my<size_y )
						offset=offset+1;
				}
				if (offset>=max_file-max_show )
					offset=max_file-max_show;
				if (offset<0 )
					offset=0;
			}
			else
			{
				// Main window clicked? 
				if (mx>0 AND mx<size_x-font_x AND my<=size_y)
				{
					i = INTEGER(my/font_y)+offset;
					if (i>=0 AND i<=max_file)
					{
						name_Str = files_Str(i) ;
						n_selected=i;
						bn_clicked=1;
					}
				}
				// OK / Cancel 
				if (my>size_y+font_y*2 AND my<size_y+font_y*3)
				{
					if (mx>0 AND mx<size_x/3 )
						bn_clicked=2;
					if (mx>size_x*.66 AND mx<size_x )
						bn_clicked=3;
				}
			}
		}
		else
		{
			// Mouse released?? 
			// select:
			if (FALSE){
			} else if( (bn_clicked) == (1) ){if (MID_Str(name_Str, 0, 1)==CGStr("/") )
				goto change_folder;
			} else if( (bn_clicked) == (2) ){if ((must_exist AND DOESFILEEXIST(name_Str)) OR must_exist==FALSE )
				goto on_ok;
			} else if( (bn_clicked) == (3) ){goto on_cancel;
			}
		}
		if (KEY(14) )
		{
			if (ky_hold==0)
			{
				// Backspc 
				i=LEN(name_Str)-1;
				if (i<0 )
					i=0;
				name_Str = MID_Str(name_Str, 0, i) ;
			}
			ky_hold=14;
		}
		else
		{
			if (KEY(28) )
			{
				ky_hold=28;
				goto on_ok;
				// Enter / OK 
			}
			else
			{
				ky_hold=0;
				name_Str=name_Str+INKEY_Str() ;
			}
		}
		SHOWSCREEN();
		HIBERNATE();
	}
change_folder:;
	if (MID_Str(name_Str, 0, 1) == CGStr("/") )
	{
		name_Str = MID_Str(name_Str, 1, 2048) ;
		SETCURRENTDIR(name_Str) ;
	}
	goto sort_n_show;
on_cancel:;
	SETCURRENTDIR(old_dir_Str) ;
	FILLRECT(0,0, 2048, 2048, RGB(0,0,0));
	return "NO_FILE" ;
on_ok:;
	FILLRECT(0,0, 2048, 2048, RGB(0,0,0));
	DGStr rv = GETCURRENTDIR_Str() + name_Str;
	SETCURRENTDIR(old_dir_Str) ;
	return rv;
}
