#if 0

#ifndef BMP_H
#define BMP_H

// - HEADERS ---------------------------------------------------
#include <windows.h>
#include <stdio.h>



// - OBJECTS ---------------------------------------------------
struct oBMPFileHeader
{
	unsigned short Type; 
	unsigned long  Size; 
	unsigned short Reserved1; 
	unsigned short Reserved2; 
	unsigned long  Offset; 
};

struct oBMPInfoHeader
{
	unsigned short Size; 
	long           Width; 
	long           Height; 
	unsigned short Planes; 
	unsigned short BitDepth; 
	unsigned long  Compression; 
	unsigned long  BitmapSize;
	long           PixelsPerMeterX; 
	long           PixelsPerMeterY; 
	unsigned long  NumUsedColors; 
	unsigned long  NumImportantColors;
};

struct oBMP
{
	oBMPFileHeader FileHeader;
	oBMPInfoHeader InfoHeader;

	unsigned char *Bitmap;

	unsigned char ColorDepth;
	unsigned int  Flag;

	oBMP();
	~oBMP();
	//void FromScreen(); // Screenshot
	void XButton();
	void DefaultFont();
	void Create(const char *argPathname);
	// void CreateOld(const char *argPathname);
	static bool Dimensions(const char* argPathname, short* pX, short *pY);
	void Delete(void);
};


#endif

#endif
