#ifndef KEYBOARD_H
#define KEYBOARD_H


// - HEADERS ---------------------------------------------------

#include <windows.h>
#include "oScreen.h"

// - OBJECTS ---------------------------------------------------

class oKeyboard
{
public:
	oKeyboard();
	~oKeyboard();
	void Create(HWND hwnd);
	void Delete(void);

	int GetMappedKeyState(int c);

private:
#ifdef _WIN32_WCE
//	int hooktab[15];
#endif
	HWND hGrabWindow;
	void InitGrabButtons(HWND hwnd);
	void GrabButton(int keyid, bool grab=true);
	void ActivateButtons(bool active);
};


// - EXTERNALS -------------------------------------------------

extern oKeyboard Keyboard;


#endif

