#include <stdio.h>
#include <iostream>
#include <cstring>
#include <sys/mman.h>
extern "C" {
	#include <libcastor.h>
}
using namespace std;

int main(int argc, char* argv[]) {
	printf("libcastor test app 0.1 by orkie\n\n");
	if(lc_init() < 0) {
		printf("Could not start libcastor\n");
		return 1;
	}

	int i, j;
	for(i = 0 ; i < 10 ; i++) {
		for(j = 0 ; j < 240 ; j++) {
			fb1[(i*240)+j] = 0xFFFF;
		}
	}
	for(i = 10 ; i < 160 ; i++) {
		for(j = 0 ; j < 240 ; j++) {
			fb1[(i*240)+j] = 0xF800;
		}
	}
	for(i = 160 ; i < 310 ; i++) {
		for(j = 0 ; j < 240 ; j++) {
			fb1[(i*240)+j] = 0x001F;
		}
	}
	for(i = 310 ; i < 320 ; i++) {
		for(j = 0 ; j < 240 ; j++) {
			fb1[(i*240)+j] = 0x07E0;
		}
	}
		/*for(i = 0 ; i < 10 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0xFFFF;
			}
		}
		for(i = 10 ; i < 160 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0xF800;
			}
		}
		for(i = 160 ; i < 310 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0x001F;
			}
		}
		for(i = 310 ; i < 320 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0x07E0;
			}
		}*/

	printf("sleeping\n");
	int addr, val, sze;
	char cmd;
	int run = 1;
	while(run) {
		scanf("%c%d %x %d", &cmd, &sze, &addr, &val);
		if(cmd == 'r') {
			if(sze == 32)	printf("%.8x\n", memregs32[addr>>2]);
			if(sze == 16)	printf("%.4x\n", memregs16[addr>>1]);
			if(sze == 8)	printf("%.2x\n", memregs8[addr]);
		} else if(cmd == 'w') {
			memregs32[addr>>2] = val;
			memregs16[addr>>1] = val;
			memregs8[addr] = val;
		}
			
		/*lc_screensize(240, 320);
		lc_layerpos(1, 0, 0, 239, 319);
		DPCVTOTAL = 240;
		for(i = 0 ; i < 10 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0xFFFF;
			}
		}
		for(i = 10 ; i < 160 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0xF800;
			}
		}
		for(i = 160 ; i < 310 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0x001F;
			}
		}
		for(i = 310 ; i < 320 ; i++) {
			for(j = 0 ; j < 240 ; j++) {
				fb1[(j*320)+i] = 0x07E0;
			}
		}*/
	}

	lc_exit();
	return 0;
}
	

