//
//  UIDeviceHardware.m
//
//  Used to determine EXACT version of device software is running on.

#include <sys/types.h>
#include <sys/sysctl.h>
#import <Foundation/NSString.h>
#import <string.h>
#import <stdlib.h>
#import <AssetsLibrary/AssetsLibrary.h>
char iDevice[256]="";

const char* deviceName()
{	int name[] = {CTL_HW,HW_MACHINE}; 
	size_t size = 100; 
	sysctl(name, 2, NULL, &size, NULL, 0); // getting size of answer 
	char *hw_machine = malloc(size); 
	sysctl(name, 2, hw_machine, &size, NULL, 0); 
	NSString *hardware = [NSString stringWithUTF8String:hw_machine];
	strcpy(iDevice, [hardware UTF8String]);
	free(hw_machine); 
	
	return iDevice; 
}


int checkSetting(const char* name)
{	NSString *Name = [[NSString alloc] initWithUTF8String:name];
	if ([[NSUserDefaults standardUserDefaults] boolForKey:Name])
	{	return 1; }
	return 0;
}

int copySnapshot(const char* name)
{	NSString *Name = [[NSString alloc] initWithUTF8String:name];
	UIImage *myImage = [UIImage imageWithContentsOfFile:Name];
	UIImageWriteToSavedPhotosAlbum(myImage, nil, nil, nil);
    myImage=nil;
    return 1;
}
