

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <CoreMotion/CoreMotion.h>
#import <UIKit/UIApplication.h>
#import "iCade/iCadeReaderView.h"
#import "iPhoneViewController.h" /* DaCarSoft */
#import <GameController/GameController.h> // Space Fractal :: MFI Controller support.



@class EAGLView;

//CLASS INTERFACES:

@interface AppController : NSObject <UIApplicationDelegate, UIAccelerometerDelegate>
{
	UIWindow			*window;
	EAGLView			*glView;
	iCadeReaderView		*iCadeView;
    CMMotionManager      *motionManager;
    
    
    iPhoneViewController *iPhoneViewControllerWithRotation; /* DaCarSoft */
    
}
@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet EAGLView *glView;
@property (nonatomic) CGPoint center;
@property (nonatomic, assign) BOOL controllerConnected; // Space Fractal :: MFI Controller support.
@property (nonatomic, strong) GCController * gameController; // Space Fractal :: MFI Controller support.
@property (nonatomic, assign) int controllerType; // Space Fractal :: MFI Controller support.

//-(void)startAccelerometerData();

@end

// EXPORT:
#ifdef __cplusplus
extern "C"{
#endif
	void iPhoneGetAcceleration(float* x, float* y, float* z);
	void iPhonePumpEvents(unsigned long milliseconds);
	void iPhoneRumble();
	int	 isIphone();
	void iPhoneAlert();
    void iPhoneGetMouseData(int iMouse, int* x, int* y, int* button);
    int iPhonePausemode(); // safe pause mode without callback
    int  updateiosgamecontroller();  // space fractal
    float getgamecontrollerfloat(int button); // space fractal
    int controllerconnected(); // space fractal
    
	const char* iPhoneVersion(); // "2.2.1" e.g.
	const char* iPhoneDeviceID();
	float		iPhoneBattery();
	const char* iPhoneGetExePath();
	void		iPhonePlayMovie(const char* pMoviePath);
#ifdef __cplusplus
} // extern "C"
#endif
